var ZINDEX_FRONT = 5;
 
document.write("<div id='yFlex.body'></div>");

/**
 * フローティング HTML レイヤー管理用のベースオブジェクト
 * これを元に HTML レイヤーを作ることで ActionScript 側からの呼び出し、配置が
 * 容易に行えるようになっている。
 */
function yFlex(html, properties, obj){
	yFlex.lastId++;
	this.id = "yFlex." + yFlex.lastId;
	
	this.div = document.createElement("div");
	this.div.id = this.id;
	this.div.style.position = "absolute";
	this.div.style.top = "0px";
	this.div.style.left = "0px";
	this.div.style.display = "";
	this.div.style.zIndex = ZINDEX_FRONT;
	for (var i in properties) {
		this.div.style[i] = properties[i];
	}
	
	document.getElementById("yFlex.body").appendChild(this.div);
	this.div.innerHTML = html;
	if(obj)
		obj.init();
	
	this.obj = obj;
	yFlex.instanceMap[this.id] = this;
}
yFlex.lastId = 0;
yFlex.instanceMap = new Array;

function yFlex_getProperty(id, property){
	return yFlex.instanceMap[id].div.style[property];
}

function yFlex_setProperty(id, property, value){
	yFlex.instanceMap[id].div.style[property] = value;
	
	var obj = yFlex.instanceMap[id].obj;
	if(obj && (property == "width" || property == "height")){
		obj.setProperty(property, value);
	}
}

function yFlex_getHTML(id){
	return yFlex.instanceMap[id].div.innerHTML;
}

function yFlex_setHTML(id, html){
	yFlex.instanceMap[id].div.innerHTML = html;
}

function yFlex_setValue(id, value){
	if(yFlex.instanceMap[id].obj)
		yFlex.instanceMap[id].obj.set(value);
}

function yFlex_getValue(id){
	var value;
	if(yFlex.instanceMap[id].obj)
		value = yFlex.instanceMap[id].obj.get();
			
	return value;
}

function yFlex_remove(id){
	document.getElementById("yFlex.body").removeChild(document.getElementById(id));
	yFlex.instanceMap[id] = null;
}

function yFlex_setSrc(id, src){
	if(yFlex.instanceMap[id].obj)
		yFlex.instanceMap[id].obj.src(src);
}

function yFlex_createDiv(html, properties, obj){
	var f = new yFlex(html, properties, obj);
	return f.id;
}

function yFlex_createIFrame(properties, src){
	yFlex.lastId++;
	var refid = "yFlex.IFrame."+yFlex.lastId;
	
	var style = "border-width:0px;";
	if(properties.width){
		style += "width:" + properties.width + ";";
	}
	if(properties.height){
		style += "height:" + properties.height + ";";
	}
	
	var obj = _getRefefenceObject(refid, refid);
	var f = new yFlex("<iframe frameBorder='0' allowTransparency='true' style='"+style+"' src='"+src+"' id='"+refid+"' />", properties, obj);
	return f.id;
}

function _getRefefenceObject(refid, sizeid){
	var obj = new Array;
	obj.set = function(value){
		document.getElementById(refid).value = value;
	}
	obj.get = function(value){
		return document.getElementById(refid).value;
	}
	obj.src = function(value){
		document.getElementById(refid).src = value;
	}
	obj.setProperty = function(property, value){
		document.getElementById(sizeid).style[property] = value;
	}
	obj.init = function(){}
	return obj;
}


