package y.controls
{
	import y.event.*;
	import mx.events.*;
	import mx.core.*;
	import mx.controls.*;
	import mx.utils.*;
	import flash.events.*;
	import flash.external.*;
	import flash.geom.*;
	
	public class HTMLFloat extends Spacer
	{
		private var _added = false;
		protected var htmlId:String;
		protected var onHTML:Boolean;
		private var _html:String = "";

		//HTML上のオブジェクトのスタイルシートとの連携を実現するためのオブジェクト
		protected var _style:ObjectProxy = new ObjectProxy(style);
		
		//HTML上の要素の位置・サイズの更新をチェックするために現在の情報を格納
		private var lastX:Number = 0;
		private var lastY:Number = 0;
		private var lastWidth:Number = 0;
		private var lastHeight:Number = 0;
		
		//HTMLFloatのインスタンスをHTML上のidとマッピングするための配列
		public static var instanceMap:Array = [];
		
		//Javascriptからの命令を受け取るためのcallbackを設定
		ExternalInterface.addCallback("jsFlexCall",jsGlobalHandler);
		
		public function HTMLFloat(){
			super();
			addEventListener(FlexEvent.CREATION_COMPLETE,addHandler);
			addEventListener(FlexEvent.REMOVE,removeHandler); 
			addEventListener(ResizeEvent.RESIZE,resizeHandler);
			addEventListener(MoveEvent.MOVE,moveHandler);
			addEventListener(FlexEvent.SHOW,showHandler); 
			addEventListener(FlexEvent.HIDE,hideHandler);
			addEventListener(Event.ENTER_FRAME,enterFrameHandler);
			_style.addEventListener(PropertyChangeEvent.PROPERTY_CHANGE,
				styleUpdateHandler);
		}

		//HTML上のidを元にインスタンスを引き、イベントを発行するロジック
		public static function jsGlobalHandler(jsid:String,eventType:String,... args){
			var obj = instanceMap[jsid];
			if(obj)obj.jsHandler(eventType,args);
		}
		
		public function jsHandler(eventType:String,args){
			var e:JSEvent = new JSEvent(eventType);
			e.args = args;
			dispatchEvent(e);
		}
		
		//各種プロパティの設定
		public function get html():String {
            return this.innerHTML;
        }
        
        public function set html(argHtml:String):void {
            this.innerHTML = argHtml;
        }
        
		public function get innerHTML():String {
			if(onHTML){
            	return ExternalInterface.call("yFlex_getHTML",htmlId);
        	}else{
            	return _html;
			}
        }
        
        public function set innerHTML(argHtml:String):void {
        	_html = argHtml;
        	if(onHTML){
            	ExternalInterface.call("yFlex_setHTML",htmlId,argHtml);
        	}
        }
        
		public function get divId():String {
            return htmlId;
        }
        
		public function get style():Object {
            return _style;
        }

		public function set style(obj:Object):void {
            _style = ObjectProxy(style);
        }
        
        //HTMLFloatがFlash上に張られるとaddHandlerが呼び出され、HTML上の要素を生成する
		private function addHandler(event:Event):void{
			htmlId = createContent();
			instanceMap[htmlId] = this;
			onHTML = true;
			this.style.display = "";
			_added = true
		}

		protected function createContent():String{
			return ExternalInterface.call("yFlex_createDiv",_html,_style,null);
		} 
		
		
		private function removeHandler(event:Event):void{
			ExternalInterface.call("yFlex_remove",htmlId);
			onHTML = false;
		}
				
		private function resizeHandler(event:Event):void{
			if(!_added) return;
			fixupLocation();
		}
		
		private function moveHandler(event:Event):void{
			if(!_added) return;
			fixupLocation();
		}
		
		private function enterFrameHandler(event:Event):void{
			if(!_added) return;
			fixupLocation();
		}
		
		private function showHandler(event:Event):void{
			this.style.display = "";
		}
		private function hideHandler(event:Event):void{
			this.style.display = "none";
		}
		
		//Flash側のレイアウトが変更された場合、位置・サイズをHTML側に伝えて更新を実施する
		private function fixupLocation():void{
			var q:Point = new Point();
			var p:Point = localToGlobal(q);
		
			if(lastX != p.x){
				this.style.left = p.x;
				lastX = p.x;
			}
			if(lastY != p.y){
				this.style.top = p.y;
				lastY = p.y;
			}
			if(lastWidth != this.width){
				this.style.width = this.width + "px";
				lastWidth = this.width;
			}
			if(lastHeight != this.height){
				this.style.height = this.height + "px";
				lastHeight = this.height;
			}
		}
		
		
		//_styleのpropertyの更新を受けてHTML側にpropertyの更新を要求する
		private function styleUpdateHandler(event:PropertyChangeEvent):void{
			if(onHTML){
				if(event.kind == PropertyChangeEventKind.DELETE){
					ExternalInterface.call("yFlex_setProperty",
						htmlId,event.property,null);
				}else if(event.kind == PropertyChangeEventKind.UPDATE){
					ExternalInterface.call("yFlex_setProperty",
						htmlId,event.property,event.newValue);
				}
			}
		}
	}
}


